<?php
/**
 * @package		Joomla.Administrator
 * @subpackage	com_cpanel
 * @copyright	Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.
 * @license		GNU GPL 2 or later; see LICENSE.txt
 */

// no direct access
defined('_JEXEC') or die;
?>
<div class="adminform">
	
	<div class="cpanel-left">
	<?php
		echo JHtml::_('sliders.start', 'ce-cpanel-sliders', array('useCookie'=>'1'));
		
		foreach ($this->modules as $module) {
			$output = JModuleHelper::renderModule($module);
			$params = new JRegistry;
			$params->loadString($module->params);
			if ($params->get('automatic_title', '0')=='0') {
				echo JHtml::_('sliders.panel', $module->title, 'ce-cpanel-panel-'.$module->name);
			}
			elseif (method_exists('mod'.$module->name.'Helper', 'getTitle')) {
				echo JHtml::_('sliders.panel', call_user_func_array(array('mod'.$module->name.'Helper', 'getTitle'), array($params)), 'ce-cpanel-panel-'.$module->name);
			}
			else {
				echo JHtml::_('sliders.panel', JText::_('MOD_'.$module->name.'_TITLE'), 'ce-cpanel-panel-'.$module->name);
			}
			echo $output;
		}
		
		echo JHtml::_('sliders.end');
		?>
	</div>
	
	<div class="cpanel-right">
		<?php if (count($this->icons) >1):?>
			<?php
				echo JHtml::_('sliders.start', 'ce-icon-sliders', array('useCookie'=>'1'));
				
				foreach ($this->icons as $module) {
					$output = JModuleHelper::renderModule($module);
					$params = new JRegistry;
					$params->loadString($module->params);
					if ($params->get('automatic_title', '0')=='0') {
						echo JHtml::_('sliders.panel', $module->title, 'ce-icon-panel-'.$module->name);
					}
					elseif (method_exists('mod'.$module->name.'Helper', 'getTitle')) {
						echo JHtml::_('sliders.panel', call_user_func_array(array('mod'.$module->name.'Helper', 'getTitle'), array($params)), 'ce-icon-panel-'.$module->name);
					}
					else {
						echo JHtml::_('sliders.panel', JText::_('MOD_'.$module->name.'_TITLE'), 'ce-icon-panel-'.$module->name);
					}
					echo $output;
				}
				
				echo JHtml::_('sliders.end');
				?>
		<?php elseif(isset($this->icons[0])):?>
			<?php
					$module = &$this->icons[0];
					$output = JModuleHelper::renderModule($module);
					$params = new JRegistry;
					$params->loadString($module->params);
					echo $output;
				?>
		<?php endif;?>
	</div>
</div>
