<?php
/**
 * @package		Joomla.Plugin
 * @subpackage	System.Jblibrary
 * @author		Joomla Bamboo - design@joomlabamboo.com
 * @copyright 	Copyright (c) 2012 Joomla Bamboo. All rights reserved.
 * @license		GNU General Public License version 2 or later
 * @version		2.0.1
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

define('JBLIBRARY_JQUERY_PATH', JURI::root(true) . '/media/plg_jblibrary/jquery/');
define('JBLIBRARY_DEFAULT_JQUERY', '1.8.2');
define('JBLIBRARY_DEFAULT_MOOTOOLS', '1.4.5');

class LibraryHelper
{
	public static function getBrowser()
	{
		return substr((string) $_SERVER['HTTP_USER_AGENT'], 25, 8);
	}

	public static function browserIsIE60()
	{
		return self::getBrowser() === 'MSIE 6.0';
	}

	public static function setJQueryLoadedFlag()
	{
		$app = JFactory::getApplication();

		if (version_compare(JVERSION, '3.0', '<'))
		{
			$app->set('jquery', true);
		}
		else
		{
			$app->jquery = true;
		}
	}

	public static function checkJQueryLoadedFlag()
	{
		$app = JFactory::getApplication();

		if (version_compare(JVERSION, '3.0', '<'))
		{
			return (bool) $app->get('jquery');
		}
		else
		{
			return isset($app->jquery) && (bool) $app->jquery === true;
		}
	}

	public static function getJQueryPath($version = 'latest', $source = 'google')
	{
		$path = '';

		// Check jQuery Version
		if ($version === 'latest')
		{
			if ($source === 'google')
			{
				$path = 'http://ajax.googleapis.com/ajax/libs/jquery/1/jquery.min.js';
			}
			elseif ($source === 'jquery')
			{
				$path = 'http://code.jquery.com/jquery-latest.min.js';
			}
		}
		else
		{
			if ($source === 'local')
			{
				$path = JBLIBRARY_JQUERY_PATH . 'jquery-' . $version . '.min.js';
			}
			elseif ($source === 'google')
			{
				$path = 'http://ajax.googleapis.com/ajax/libs/jquery/' . $version . '/jquery.min.js';
			}
			elseif ($source === 'jquery')
			{
				$path = 'http://code.jquery.com/jquery-' . $version . '.min.js';
			}
		}

		// Tell other extensions jQuery has been loaded
		self::setJQueryLoadedFlag();

		return $path;
	}

	public static function isExternalPath($path = '')
	{
		if (!empty($path))
		{
			return substr($path, 0, 4) === 'http';
		}

		return false;
	}
}
