<?php
/**
 * @version		2.5.0
 * @package		com_contactenhanced
 * @subpackage	mod_ce_contactslider
 * @copyright	Copyright (C) 2005 - 2013 IdealExtensions.com. All rights reserved.
 * @license		GNU GPL 2 or later; see LICENSE.txt
 */

// no direct access
defined('_JEXEC') or die;

require_once JPATH_SITE.'/components/com_contactenhanced/helpers/route.php';
require_once JPATH_SITE.'/components/com_contactenhanced/helpers/helper.php';
require_once JPATH_SITE.'/components/com_contactenhanced/helpers/image.php';
jimport('joomla.application.component.model');
JModel::addIncludePath(JPATH_SITE.'/components/com_contactenhanced/models');
JHTML::_('behavior.framework',true);
JHTML::_('behavior.framework');


class modCEContactSliderHelper {
	/**
	 * get instance of modCEContactSliderHelper
	 */
	function getInstance(){
		static $__instance = null;
		if( !$__instance ){
			$__instance = new modCEContactSliderHelper();
		}
		return $__instance;
	}
	public static function contactHREF(&$item, &$params) {
		$document	= JFactory::getDocument();

		// Access filter
		$access = !JComponentHelper::getParams('com_contactenhanced')->get('show_noauth');
		$authorised = JAccess::getAuthorisedViewLevels(JFactory::getUser()->get('id'));

		$item->slug = $item->id.':'.$item->alias;
		$item->catslug = $item->catid.':'.$item->category_alias;

		if ($access || in_array($item->access, $authorised))
		{
			// We know that user has the privilege to view the article
			$item->href = (ContactenchancedHelperRoute::getContactRoute($item->slug, $item->catslug));
		}
		else {
			$app	= JFactory::getApplication();
			$menu	= $app->getMenu();
			$menuitems	= $menu->getItems('link', 'index.php?option=com_users&view=login');
			if(isset($menuitems[0])) {
				$Itemid = $menuitems[0]->id;
			} else if (JRequest::getInt('Itemid') > 0) { //use Itemid from requesting page only if there is no existing menu
				$Itemid = JRequest::getInt('Itemid');
			}

			$item->href = ('index.php?option=com_users&view=login&Itemid='.$Itemid);
		}

		if($params->get('modal',0)){
			$item->href	.=	'&amp;content_title='.ceHelper::encode($document->getTitle())
							.'&amp;content_url='.ceHelper::encode(ceHelper::getCurrentURL())
							.'&amp;tmpl=component'
							.($params->get('template') ? '&amp;template='.$params->get('template') : '')
							;
		}else{
			$item->href	= JRoute::_($item->href);
		}
		return $item->href;
	}

	public static function getList(&$params)
	{
		$lang	= JFactory::getLanguage();
		$lang->load('com_contactenhanced');

		// Get an instance of the generic contacts model
		$contacts = JModel::getInstance('Contacts', 'ContactenhancedModel', array('ignore_request' => true));

		// Set application parameters in model
		$app = JFactory::getApplication();
		$appParams	= $app->getParams();
		$comParams	= JComponentHelper::getParams('com_contactenhanced');


		$appParams->merge($comParams);


		$contacts->setState('params', $appParams);

		// Set the filters based on the module params
		$contacts->setState('list.start', 0);
		$contacts->setState('list.limit', (int) $params->get('maxitems', 0));
		$contacts->setState('filter.published', 1);

		$contacts->setState(
			'a.id, a.name, a.alias, a.name AS title, a.alias AS title_alias, a.params, ' .
				'a.checked_out, a.checked_out_time, ' .
				'a.misc, a.con_position, a.address, a.suburb, a.state , a.country, a.postcode,'.
				' a.telephone, a.fax, a.mobile, a.skype, a.twitter, a.facebook, a.linkedin, a.webpage, a.image,'.
				' a.extra_field_1, a.extra_field_2, a.extra_field_3, a.extra_field_4, a.extra_field_5,'.
				' a.extra_field_6, a.extra_field_7, a.extra_field_8, a.extra_field_9, a.extra_field_10,'.
				'a.lat, a.lng, a.email_to,'.
				'a.catid, a.created, a.created_by, a.created_by_alias, ' .
				' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(\':\', a.id, a.alias) ELSE a.id END as slug, ' .
				// use created if modified is 0
				'CASE WHEN a.modified = 0 THEN a.created ELSE a.modified END as modified, ' .
					'a.modified_by, uam.name as modified_by_name,' .
				// use created if publish_up is 0
				'CASE WHEN a.publish_up = 0 THEN a.created ELSE a.publish_up END as publish_up, ' .
					'a.publish_down, a.metadata, a.metakey, a.metadesc, a.access, '.
					'a.xreference, a.featured '
		);


		// Access filter
		$access = !JComponentHelper::getParams('com_contactenhanced')->get('show_noauth');
		$authorised = JAccess::getAuthorisedViewLevels(JFactory::getUser()->get('id'));
		$contacts->setState('filter.access', $access);





		// Prep for Normal or Dynamic Modes
		$moduleMode = $params->get('module_mode', 'normal');

		switch ($moduleMode)
		{
			case 'dynamic':
				$option = JRequest::getCmd('option');
				$view = JRequest::getCmd('view');
				if ($option === 'com_contactenhanced') {
					switch($view)
					{
						case 'category':
							$catids = array(JRequest::getInt('id'));
							break;
						case 'categories':
							$catids = array(JRequest::getInt('id'));
							break;
						case 'contact':
							if ($params->get('module_mode-dynamic-show_on_contact_page', 1)) {
								$contact_id = JRequest::getInt('id');
								$catid = JRequest::getInt('catid');

								if (!$catid) {
									// Get an instance of the generic contact model
									$contact = JModel::getInstance('Contact', 'ContactenhancedModel', array('ignore_request' => true));

									$contact->setState('params', $appParams);
									$contact->setState('filter.published', 1);
									$contact->setState('contact.id', (int) $contact_id);
									$contact	= $contact->getItem();
									$catids = array($contact->catid);
								}
								else {
									$catids = array($catid);
								}
							}
							else {
								// Return right away if show_on_contact_page option is off
								return array();
							}
							break;

						case 'featured':
						default:
							// Return right away if not on the category or contact views
							return;
					}
				}
				elseif($params->get('module_mode-dynamic-show_on_contactenhanced_pages_only', 0)) {
					// Return right away if not on a com_contactenhanced page
					return array();
				}else{
					//Mimics normal module mode
					$catids = $params->get('catid');
					$contacts->setState('filter.category_id.include', (bool) $params->get('category_filtering_type', 1));
				}

				break;

			case 'normal':
			default:
				$catids = $params->get('catid');
				$contacts->setState('filter.category_id.include', (bool) $params->get('category_filtering_type', 1));
				break;
		}

		// Category filter
		if ($catids
			AND !((is_array($catids) AND count($catids) == 1 AND $catids[0] == 0)) // If there is only one category and it is 0
		){
			if(is_array($catids)){
				$catids	= implode(',',$catids);
			}
			$contacts->setState('filter.category_id', $catids);
		}

		// Ordering
		$contacts->setState('list.ordering',	$params->get('contact_ordering', 'a.ordering'));
		$contacts->setState('list.direction',	$params->get('contact_ordering_direction', 'ASC'));

		// New Parameters
		//$contacts->setState('filter.featured', $params->get('show_front', 'show'));
		$excluded_contacts	= $params->get('excluded_contacts', '');

		if ($excluded_contacts) {
			$excluded_contacts = explode("\r\n",	$excluded_contacts);
			$contacts->setState('filter.contact_id',$excluded_contacts);
			$contacts->setState('filter.contact_id.include', false); // Exclude
		}

		$date_filtering	= $params->get('date_filtering', 'off');
		if ($date_filtering !== 'off') {
			$contacts->setState('filter.date_filtering',	$date_filtering);
			$contacts->setState('filter.date_field',		$params->get('date_field', 'a.created'));
			$contacts->setState('filter.start_date_range',	$params->get('date_filtering-range-start_date',	'1000-01-01 00:00:00'));
			$contacts->setState('filter.end_date_range',	$params->get('date_filtering-range-end_date',	'9999-12-31 23:59:59'));
			$contacts->setState('filter.relative_date',		$params->get('date_filtering-relative-interval',30));
		}

		// Filter by language
		$contacts->setState('filter.language',$app->getLanguageFilter());

		$items = $contacts->getItems();

		// Display options
		$show_date 			= $params->get('show_date', 0);
		$show_date_field	= $params->get('show_date_field', 'created');
		$show_date_format	= $params->get('show_date_format', 'Y-m-d H:i:s');
		$show_category		= $params->get('show_category', 0);
		$show_hits			= $params->get('show_hits', 0);
		$show_author		= $params->get('show_author', 0);
		$show_misc			= $params->get('show_misc', 0);
		$misc_limit			= $params->get('misc_limit', 40);

		// Find current Contact ID if on an contact page
		$option = JRequest::getCmd('option');
		$view = JRequest::getCmd('view');

		if ($option === 'com_contactenhanced' && $view === 'contact') {
			$active_contact_id = JRequest::getInt('id');
		}
		else {
			$active_contact_id = 0;
		}
		$params->set('icon_address',	$comParams->get('icon_address'));
		$params->set('icon_email',		$comParams->get('icon_email'));
		$params->set('icon_telephone',	$comParams->get('icon_telephone'));
		$params->set('icon_mobile',		$comParams->get('icon_mobile'));
		$params->set('icon_fax',		$comParams->get('icon_fax'));
		$params->set('icon_misc',		$comParams->get('icon_misc'));
		$params->set('icon_skype',		$comParams->get('icon_skype'));

		$params->set('icon_twitter',	$comParams->get('icon_twitter'));
		$params->set('icon_facebook',	$comParams->get('icon_facebook'));
		$params->set('icon_linkedin',	$comParams->get('icon_linkedin'));
		$params->set('icon_website',	$comParams->get('icon_website'));
		$params->set('icon_birthdate',	$comParams->get('icon_birthdate'));
		$params->set('icon_extra_field_1',	$comParams->get('icon_extra_field_1'));
		$params->set('icon_extra_field_2',	$comParams->get('icon_extra_field_2'));
		$params->set('icon_extra_field_3',	$comParams->get('icon_extra_field_3'));
		$params->set('icon_extra_field_4',	$comParams->get('icon_extra_field_4'));
		$params->set('icon_extra_field_5',	$comParams->get('icon_extra_field_5'));
		$params->set('icon_extra_field_6',	$comParams->get('icon_extra_field_6'));
		$params->set('icon_extra_field_7',	$comParams->get('icon_extra_field_7'));
		$params->set('icon_extra_field_8',	$comParams->get('icon_extra_field_8'));
		$params->set('icon_extra_field_9',	$comParams->get('icon_extra_field_9'));
		$params->set('icon_extra_field_10',	$comParams->get('icon_extra_field_10'));
		$params->set('marker_class',		'jicons-none');

		// Get an instance of the generic contact model
		$contact = JModel::getInstance('Contact', 'ContactenhancedModel', array('ignore_request' => true));

		// Prepare data for display using display options
		foreach ($items as &$item)
		{

			$contact->displayParamters($params,$item);

			$item->title	= $item->name;
			$item->cateName = $item->category_title;
			$item->href		= modCEContactSliderHelper::contactHREF($item, $params);

			if($item->image){
				$item->image = modCEContactSliderHelper::renderImage( $item->title
																	, $item->href
																	, $item->image
																	, $params
																	, $params->get( 'images-display-width' )
																	, $params->get( 'images-display-height' ) ) ;
			}

			// Used for styling the active contact
			$item->active = $item->id == $active_contact_id ? 'active' : '';

			$item->displayDate = '';
			if ($show_date) {
				$item->displayDate = JHTML::_('date', $item->$show_date_field, $show_date_format);
			}

			if ($item->catid) {
				$item->displayCategoryLink = JRoute::_(ContactenchancedHelperRoute::getCategoryRoute($item->catid));
				$item->displayCategoryTitle = $show_category ? '<a href="'.$item->displayCategoryLink.'">'.$item->category_title.'</a>' : '';
			}
			else {
				$item->displayCategoryTitle = $show_category ? $item->category_title : '';
			}

			//$item->displayHits	= $show_hits ? $item->hits : '';
			$item->displayHits	= '';

			if ($show_misc AND $item->misc) {
				$item->misc			= JHtml::_('content.prepare', $item->misc);
				$item->misc			= self::_cleanMisc($item->misc);
			}
			$item->displayMisc	= $show_misc ? self::truncate($item->misc, $misc_limit) : '';
		}
		return $items;
	}


	public static function renderImage( $title, $link, $image, $params, $width = 0, $height = 0, $attrs='', $returnURL=false ) {
		global $database, $current_charset;
		if ( $image ) {
			$title = strip_tags( $title );
			$thumbnailMode = $params->get( 'thumbnail_mode', 'crop' );
			$aspect 	   = $params->get( 'thumbnail_mode-resize-use_ratio', '1' );
			$crop = $thumbnailMode == 'crop' ? true:false;
			$ceImageHelper = ceImageHelper::getInstance();
			if( $thumbnailMode != 'none' && $ceImageHelper->sourceExited($image) ) {
				$imageURL = $ceImageHelper->resize( $image, $width, $height, $crop, $aspect );
				if( $returnURL ){
					return $imageURL;
				}
				if ( $imageURL != $image && $imageURL ) {
					$width = $width ? "width=\"$width\"" : "";
					$height = $height ? "height=\"$height\"" : "";
					$image = "<img src=\"$imageURL\"  alt=\"{$title}\" title=\"{$title}\" $width $height $attrs />";
				} else {
					$image = "<img $attrs src=\"$image\"  $attrs  alt=\"{$title}\" title=\"{$title}\" />";
				}
			} else {
				if( $returnURL ){
					return $image;
				}
				$width = $width ? "width=\"$width\"" : "";
				$height = $height ? "height=\"$height\"" : "";
				$image = "<img $attrs src=\"$image\" alt=\"{$title}\"   title=\"{$title}\" $width $height />";
			}
		} else {
			$image = '';
		}
		$image = '<a href="'.$link.'" title="'.$title.'" class="contact-image ce-image">'.$image.'</a>';
		// clean up globals
		return $image;
	}


	/**
	 * load javascript files: processing override js, load js compress or not.
	 */
	public static function javascript( $params  ){

		$document =JFactory::getDocument();
		$document->addScript( JURI::base().'modules/mod_ce_contactslider/assets/js/ce_contactslider.js' );
	}
	/**
	 * load css files: processing override css
	 */
	public static function css( $params ){

		$mainframe = JFactory::getApplication();

		$document =JFactory::getDocument();

		$cssFile  = 'ce_contactslider.css';

		if( file_exists(JPATH_SITE.DS.'templates'.DS.$mainframe->getTemplate().DS.'css'.DS.$cssFile) ) {
			$document->addStyleSheet( JURI::base().'templates/'.$mainframe->getTemplate().'/css/'.$cssFile );
		} else {
			$document->addStyleSheet( JURI::base().'modules/mod_ce_contactslider/assets/css/ce_contactslider.css' );
		}
	}
	/**
	 * check overrider layout.
	 */
	public static function getLayoutPath($module, $layout = 'default') {

		$mainframe = JFactory::getApplication();

		// Build the template and base path for the layout
		$tPath = JPATH_BASE.DS.'templates'.DS.$mainframe->getTemplate().DS.'html'.DS.$module.DS.$layout.'.php';
		$bPath = JPATH_BASE.DS.'modules'.DS.$module.DS.'tmpl'.DS.$layout.'.php';

		// If the template has a layout override use it
		if (file_exists($tPath)) {
			return $tPath;
		} else {
			return $bPath;
		}
	}

	public static function _cleanMisc($misc)
	{
		$misc = str_replace('<p>', ' ', $misc);
		$misc = str_replace('</p>', ' ', $misc);
		$misc = strip_tags($misc, '<a><em><strong>');

		$misc = trim($misc);

		return $misc;
	}


	/**
	* This is a better truncate implementation than what we
	* currently have available in the library. In particular,
	* on index.php/Banners/Banners/site-map.html JHtml's truncate
	* method would only return "Contact...". This implementation
	* was taken directly from the Stack Overflow thread referenced
	* below. It was then modified to return a string rather than
	* print out the output and made to use the relevant JString
	* methods.
	*
	* @link http://stackoverflow.com/questions/1193500/php-truncate-html-ignoring-tags
	* @param mixed $html
	* @param mixed $maxLength
	*/
	public static function truncate($html, $maxLength = 0)
	{
		$printedLength = 0;
		$position = 0;
		$tags = array();

		$output = '';

		if (empty($html)) {
			return $output;
		}
		if (strlen($html) < $maxLength){
			return $html;
		}

		while ($printedLength < $maxLength && preg_match('{</?([a-z]+)[^>]*>|&#?[a-zA-Z0-9]+;}', $html, $match, PREG_OFFSET_CAPTURE, $position))
		{
			list($tag, $tagPosition) = $match[0];

			// Print text leading up to the tag.
			$str = JString::substr($html, $position, $tagPosition - $position);
			if ($printedLength + JString::strlen($str) > $maxLength) {
				$output .= JString::substr($str, 0, $maxLength - $printedLength);
				$printedLength = $maxLength;
				break;
			}

			$output .= $str;
			$lastCharacterIsOpenBracket = (JString::substr($output, -1, 1) === '<');

			if ($lastCharacterIsOpenBracket) {
				$output = JString::substr($output, 0, JString::strlen($output) - 1);
			}

			$printedLength += JString::strlen($str);

			if ($tag[0] == '&') {
				// Handle the entity.
				$output .= $tag;
				$printedLength++;
			}
			else {
				// Handle the tag.
				$tagName = $match[1][0];

				if ($tag[1] == '/') {
					// This is a closing tag.
					$openingTag = array_pop($tags);

					$output .= $tag;
				}
				else if ($tag[JString::strlen($tag) - 2] == '/') {
					// Self-closing tag.
					$output .= $tag;
				}
				else {
					// Opening tag.
					$output .= $tag;
					$tags[] = $tagName;
				}
			}

			// Continue after the tag.
			if ($lastCharacterIsOpenBracket) {
				$position = ($tagPosition - 1) + JString::strlen($tag);
			}
			else {
				$position = $tagPosition + JString::strlen($tag);
			}

		}

		// Print any remaining text.
		if ($printedLength < $maxLength && $position < JString::strlen($html)) {
			$output .= JString::substr($html, $position, $maxLength - $printedLength);
		}

		// Close any open tags.
		while (!empty($tags))
		{
			$output .= sprintf('</%s>', array_pop($tags));
		}

		$length = JString::strlen($output);
		$lastChar = JString::substr($output, ($length - 1), 1);
		$characterNumber = ord($lastChar);

		if ($characterNumber === 194) {
			$output = JString::substr($output, 0, JString::strlen($output) - 1);
		}

		$output = JString::rtrim($output);

		return $output.'&hellip;';
	}

	public static function createLink($href,$text, &$params, $attribs = null){
		$attributes	= '';

		if($params->get('modal',0)){
			JHTML::_('behavior.modal', 'a.modal');
			$attributes	.= 'rel="{handler: \'iframe\', size: {x:'.$params->get('window-size-width',800).', y:'.$params->get('window-size-height',480).'}}"';
			if (isset($attribs) AND is_array($attribs) AND isset($attribs['class'])) {
				$attribs['class'] .= ' modal';
			}else{
				$attributes	.= ' class="modal"';
			}
		}

		if (isset($attribs)) {
			if (is_array($attribs)) {
				$attribs = JArrayHelper::toString($attribs);
			}
			$attributes .= ' '.$attribs;
		}

		return JHtml::_('link', $href, $text,$attributes);
	}

}
?>
